/* score-dialog.c generated by valac 0.56.17, the Vala compiler
 * generated from score-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Tetravex.

   Copyright (C) 2010-2013 Robert Ancell
   Copyright (C) 2019 Arnaud Bonatti

   GNOME Tetravex is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   GNOME Tetravex is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this GNOME Tetravex.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SCORE_DIALOG (score_dialog_get_type ())
#define SCORE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCORE_DIALOG, ScoreDialog))
#define SCORE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCORE_DIALOG, ScoreDialogClass))
#define IS_SCORE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCORE_DIALOG))
#define IS_SCORE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCORE_DIALOG))
#define SCORE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCORE_DIALOG, ScoreDialogClass))

typedef struct _ScoreDialog ScoreDialog;
typedef struct _ScoreDialogClass ScoreDialogClass;
typedef struct _ScoreDialogPrivate ScoreDialogPrivate;

#define TYPE_HISTORY (history_get_type ())
#define HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY, History))
#define HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY, HistoryClass))
#define IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY))
#define IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY))
#define HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY, HistoryClass))

typedef struct _History History;
typedef struct _HistoryClass HistoryClass;

#define TYPE_HISTORY_ENTRY (history_entry_get_type ())
#define HISTORY_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY_ENTRY, HistoryEntry))
#define HISTORY_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY_ENTRY, HistoryEntryClass))
#define IS_HISTORY_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY_ENTRY))
#define IS_HISTORY_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY_ENTRY))
#define HISTORY_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY_ENTRY, HistoryEntryClass))

typedef struct _HistoryEntry HistoryEntry;
typedef struct _HistoryEntryClass HistoryEntryClass;
enum  {
	SCORE_DIALOG_0_PROPERTY,
	SCORE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* score_dialog_properties[SCORE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _HistoryPrivate HistoryPrivate;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ScoreDialog {
	GtkDialog parent_instance;
	ScoreDialogPrivate * priv;
};

struct _ScoreDialogClass {
	GtkDialogClass parent_class;
};

struct _ScoreDialogPrivate {
	History* history;
	HistoryEntry* selected_entry;
	GtkListStore* size_model;
	GtkListStore* score_model;
	GtkComboBox* size_combo;
	GtkTreeView* scores;
};

struct _History {
	GObject parent_instance;
	HistoryPrivate * priv;
	GList* entries;
};

struct _HistoryClass {
	GObjectClass parent_class;
};

static gint ScoreDialog_private_offset;
static gpointer score_dialog_parent_class = NULL;

VALA_EXTERN GType score_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScoreDialog, g_object_unref)
VALA_EXTERN GType history_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (History, g_object_unref)
VALA_EXTERN GType history_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HistoryEntry, g_object_unref)
VALA_EXTERN ScoreDialog* score_dialog_new (History* history,
                               guint8 size,
                               HistoryEntry* selected_entry);
VALA_EXTERN ScoreDialog* score_dialog_construct (GType object_type,
                                     History* history,
                                     guint8 size,
                                     HistoryEntry* selected_entry);
static void score_dialog_entry_added_cb (ScoreDialog* self,
                                  HistoryEntry* entry);
static void _score_dialog_entry_added_cb_history_entry_added (History* _sender,
                                                       HistoryEntry* entry,
                                                       gpointer self);
static void score_dialog_size_changed_cb (ScoreDialog* self,
                                   GtkComboBox* combo);
static void _score_dialog_size_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                          gpointer self);
static gboolean score_dialog_get_size_iter (ScoreDialog* self,
                                     guint8 requested_size,
                                     GtkTreeIter* iter);
static void score_dialog_set_size (ScoreDialog* self,
                            guint8 size);
VALA_EXTERN guint8 history_entry_get_size (HistoryEntry* self);
VALA_EXTERN GDateTime* history_entry_get_date (HistoryEntry* self);
VALA_EXTERN gchar* history_entry_get_duration_string (HistoryEntry* entry);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void score_dialog_finalize (GObject * obj);
static GType score_dialog_get_type_once (void);

static inline gpointer
score_dialog_get_instance_private (ScoreDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ScoreDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/score-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 170 "score-dialog.c"
}

static void
_score_dialog_entry_added_cb_history_entry_added (History* _sender,
                                                  HistoryEntry* entry,
                                                  gpointer self)
{
#line 40 "../src/score-dialog.vala"
	score_dialog_entry_added_cb ((ScoreDialog*) self, entry);
#line 180 "score-dialog.c"
}

static void
_score_dialog_size_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                     gpointer self)
{
#line 48 "../src/score-dialog.vala"
	score_dialog_size_changed_cb ((ScoreDialog*) self, _sender);
#line 189 "score-dialog.c"
}

ScoreDialog*
score_dialog_construct (GType object_type,
                        History* history,
                        guint8 size,
                        HistoryEntry* selected_entry)
{
	ScoreDialog * self = NULL;
	GtkStyleContext* _tmp0_;
	History* _tmp1_;
	HistoryEntry* _tmp2_;
	GtkListStore* _tmp3_;
	GtkComboBox* _tmp4_;
	GtkComboBox* _tmp5_;
	GtkComboBox* _tmp6_;
	GtkListStore* _tmp7_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp8_;
	GtkComboBox* _tmp9_;
	GtkCellRendererText* _tmp10_;
	GtkComboBox* _tmp11_;
	GtkCellRendererText* _tmp12_;
	GtkComboBox* _tmp13_;
	GtkComboBox* _tmp14_;
	GtkHeaderBar* _tmp15_;
	GtkComboBox* _tmp16_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp17_;
	GtkScrolledWindow* _tmp18_;
	GtkScrolledWindow* _tmp19_;
	GtkScrolledWindow* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkBox* content_area = NULL;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GtkScrolledWindow* _tmp26_;
	GtkListStore* _tmp27_;
	GtkTreeView* _tmp28_;
	GtkCellRendererText* _tmp29_;
	GtkTreeView* _tmp30_;
	GtkCellRendererText* _tmp31_;
	GtkCellRendererText* _tmp32_;
	GtkCellRendererText* _tmp33_;
	GtkTreeView* _tmp34_;
	GtkCellRendererText* _tmp35_;
	GtkTreeView* _tmp36_;
	GtkListStore* _tmp37_;
	GtkTreeView* _tmp38_;
	GtkScrolledWindow* _tmp39_;
	GtkTreeView* _tmp40_;
	GList* _tmp41_;
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp44_ = {0};
	gboolean _tmp45_;
#line 33 "../src/score-dialog.vala"
	g_return_val_if_fail (history != NULL, NULL);
#line 35 "../src/score-dialog.vala"
	self = (ScoreDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
#line 37 "../src/score-dialog.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 37 "../src/score-dialog.vala"
	gtk_style_context_add_class (_tmp0_, "score-dialog");
#line 39 "../src/score-dialog.vala"
	_tmp1_ = _g_object_ref0 (history);
#line 39 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->history);
#line 39 "../src/score-dialog.vala"
	self->priv->history = _tmp1_;
#line 40 "../src/score-dialog.vala"
	g_signal_connect_object (history, "entry-added", (GCallback) _score_dialog_entry_added_cb_history_entry_added, self, 0);
#line 41 "../src/score-dialog.vala"
	_tmp2_ = _g_object_ref0 (selected_entry);
#line 41 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->selected_entry);
#line 41 "../src/score-dialog.vala"
	self->priv->selected_entry = _tmp2_;
#line 43 "../src/score-dialog.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 230, 320);
#line 45 "../src/score-dialog.vala"
	_tmp3_ = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_INT, -1);
#line 45 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->size_model);
#line 45 "../src/score-dialog.vala"
	self->priv->size_model = _tmp3_;
#line 47 "../src/score-dialog.vala"
	_tmp4_ = (GtkComboBox*) gtk_combo_box_new ();
#line 47 "../src/score-dialog.vala"
	g_object_ref_sink (_tmp4_);
#line 47 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->size_combo);
#line 47 "../src/score-dialog.vala"
	self->priv->size_combo = _tmp4_;
#line 48 "../src/score-dialog.vala"
	_tmp5_ = self->priv->size_combo;
#line 48 "../src/score-dialog.vala"
	g_signal_connect_object (_tmp5_, "changed", (GCallback) _score_dialog_size_changed_cb_gtk_combo_box_changed, self, 0);
#line 49 "../src/score-dialog.vala"
	_tmp6_ = self->priv->size_combo;
#line 49 "../src/score-dialog.vala"
	_tmp7_ = self->priv->size_model;
#line 49 "../src/score-dialog.vala"
	gtk_combo_box_set_model (_tmp6_, (GtkTreeModel*) _tmp7_);
#line 50 "../src/score-dialog.vala"
	_tmp8_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 50 "../src/score-dialog.vala"
	g_object_ref_sink (_tmp8_);
#line 50 "../src/score-dialog.vala"
	renderer = _tmp8_;
#line 51 "../src/score-dialog.vala"
	_tmp9_ = self->priv->size_combo;
#line 51 "../src/score-dialog.vala"
	_tmp10_ = renderer;
#line 51 "../src/score-dialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp9_, (GtkCellRenderer*) _tmp10_, TRUE);
#line 52 "../src/score-dialog.vala"
	_tmp11_ = self->priv->size_combo;
#line 52 "../src/score-dialog.vala"
	_tmp12_ = renderer;
#line 52 "../src/score-dialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp11_, (GtkCellRenderer*) _tmp12_, "text", 0);
#line 53 "../src/score-dialog.vala"
	_tmp13_ = self->priv->size_combo;
#line 53 "../src/score-dialog.vala"
	g_object_set ((GtkWidget*) _tmp13_, "width-request", 90, NULL);
#line 54 "../src/score-dialog.vala"
	_tmp14_ = self->priv->size_combo;
#line 54 "../src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp14_);
#line 55 "../src/score-dialog.vala"
	_tmp15_ = gtk_dialog_get_header_bar ((GtkDialog*) self);
#line 55 "../src/score-dialog.vala"
	_tmp16_ = self->priv->size_combo;
#line 55 "../src/score-dialog.vala"
	gtk_header_bar_set_custom_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_header_bar_get_type (), GtkHeaderBar), (GtkWidget*) _tmp16_);
#line 57 "../src/score-dialog.vala"
	_tmp17_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 57 "../src/score-dialog.vala"
	g_object_ref_sink (_tmp17_);
#line 57 "../src/score-dialog.vala"
	scroll = _tmp17_;
#line 58 "../src/score-dialog.vala"
	_tmp18_ = scroll;
#line 58 "../src/score-dialog.vala"
	gtk_scrolled_window_set_shadow_type (_tmp18_, GTK_SHADOW_ETCHED_IN);
#line 59 "../src/score-dialog.vala"
	_tmp19_ = scroll;
#line 59 "../src/score-dialog.vala"
	gtk_scrolled_window_set_policy (_tmp19_, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 60 "../src/score-dialog.vala"
	_tmp20_ = scroll;
#line 60 "../src/score-dialog.vala"
	gtk_scrolled_window_set_shadow_type (_tmp20_, GTK_SHADOW_NONE);
#line 61 "../src/score-dialog.vala"
	_tmp21_ = scroll;
#line 61 "../src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp21_);
#line 63 "../src/score-dialog.vala"
	_tmp22_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 63 "../src/score-dialog.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 63 "../src/score-dialog.vala"
	content_area = _tmp23_;
#line 64 "../src/score-dialog.vala"
	_tmp24_ = content_area;
#line 64 "../src/score-dialog.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp24_, (guint) 0);
#line 65 "../src/score-dialog.vala"
	_tmp25_ = content_area;
#line 65 "../src/score-dialog.vala"
	_tmp26_ = scroll;
#line 65 "../src/score-dialog.vala"
	gtk_box_pack_start (_tmp25_, (GtkWidget*) _tmp26_, TRUE, TRUE, (guint) 0);
#line 67 "../src/score-dialog.vala"
	_tmp27_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, -1);
#line 67 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->score_model);
#line 67 "../src/score-dialog.vala"
	self->priv->score_model = _tmp27_;
#line 69 "../src/score-dialog.vala"
	_tmp28_ = (GtkTreeView*) gtk_tree_view_new ();
#line 69 "../src/score-dialog.vala"
	g_object_ref_sink (_tmp28_);
#line 69 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->scores);
#line 69 "../src/score-dialog.vala"
	self->priv->scores = _tmp28_;
#line 70 "../src/score-dialog.vala"
	_tmp29_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 70 "../src/score-dialog.vala"
	g_object_ref_sink (_tmp29_);
#line 70 "../src/score-dialog.vala"
	_g_object_unref0 (renderer);
#line 70 "../src/score-dialog.vala"
	renderer = _tmp29_;
#line 72 "../src/score-dialog.vala"
	_tmp30_ = self->priv->scores;
#line 72 "../src/score-dialog.vala"
	_tmp31_ = renderer;
#line 72 "../src/score-dialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp30_, -1, _ ("Date"), (GtkCellRenderer*) _tmp31_, "text", 0, "weight", 2, NULL);
#line 73 "../src/score-dialog.vala"
	_tmp32_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 73 "../src/score-dialog.vala"
	g_object_ref_sink (_tmp32_);
#line 73 "../src/score-dialog.vala"
	_g_object_unref0 (renderer);
#line 73 "../src/score-dialog.vala"
	renderer = _tmp32_;
#line 74 "../src/score-dialog.vala"
	_tmp33_ = renderer;
#line 74 "../src/score-dialog.vala"
	g_object_set ((GtkCellRenderer*) _tmp33_, "xalign", 1.0f, NULL);
#line 76 "../src/score-dialog.vala"
	_tmp34_ = self->priv->scores;
#line 76 "../src/score-dialog.vala"
	_tmp35_ = renderer;
#line 76 "../src/score-dialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp34_, -1, _ ("Time"), (GtkCellRenderer*) _tmp35_, "text", 1, "weight", 2, NULL);
#line 77 "../src/score-dialog.vala"
	_tmp36_ = self->priv->scores;
#line 77 "../src/score-dialog.vala"
	_tmp37_ = self->priv->score_model;
#line 77 "../src/score-dialog.vala"
	gtk_tree_view_set_model (_tmp36_, (GtkTreeModel*) _tmp37_);
#line 78 "../src/score-dialog.vala"
	_tmp38_ = self->priv->scores;
#line 78 "../src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp38_);
#line 79 "../src/score-dialog.vala"
	_tmp39_ = scroll;
#line 79 "../src/score-dialog.vala"
	_tmp40_ = self->priv->scores;
#line 79 "../src/score-dialog.vala"
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
#line 81 "../src/score-dialog.vala"
	_tmp41_ = history->entries;
#line 429 "score-dialog.c"
	{
		GList* entry_collection = NULL;
		GList* entry_it = NULL;
#line 81 "../src/score-dialog.vala"
		entry_collection = _tmp41_;
#line 81 "../src/score-dialog.vala"
		for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
#line 437 "score-dialog.c"
			HistoryEntry* _tmp42_;
			HistoryEntry* entry = NULL;
#line 81 "../src/score-dialog.vala"
			_tmp42_ = _g_object_ref0 ((HistoryEntry*) entry_it->data);
#line 81 "../src/score-dialog.vala"
			entry = _tmp42_;
#line 444 "score-dialog.c"
			{
				HistoryEntry* _tmp43_;
#line 82 "../src/score-dialog.vala"
				_tmp43_ = entry;
#line 82 "../src/score-dialog.vala"
				score_dialog_entry_added_cb (self, _tmp43_);
#line 81 "../src/score-dialog.vala"
				_g_object_unref0 (entry);
#line 453 "score-dialog.c"
			}
		}
	}
#line 85 "../src/score-dialog.vala"
	_tmp45_ = score_dialog_get_size_iter (self, size, &_tmp44_);
#line 85 "../src/score-dialog.vala"
	iter = _tmp44_;
#line 85 "../src/score-dialog.vala"
	if (_tmp45_) {
#line 463 "score-dialog.c"
		GtkComboBox* _tmp46_;
		GtkTreeIter _tmp47_;
#line 86 "../src/score-dialog.vala"
		_tmp46_ = self->priv->size_combo;
#line 86 "../src/score-dialog.vala"
		_tmp47_ = iter;
#line 86 "../src/score-dialog.vala"
		gtk_combo_box_set_active_iter (_tmp46_, &_tmp47_);
#line 472 "score-dialog.c"
	}
#line 33 "../src/score-dialog.vala"
	_g_object_unref0 (content_area);
#line 33 "../src/score-dialog.vala"
	_g_object_unref0 (scroll);
#line 33 "../src/score-dialog.vala"
	_g_object_unref0 (renderer);
#line 33 "../src/score-dialog.vala"
	return self;
#line 482 "score-dialog.c"
}

ScoreDialog*
score_dialog_new (History* history,
                  guint8 size,
                  HistoryEntry* selected_entry)
{
#line 33 "../src/score-dialog.vala"
	return score_dialog_construct (TYPE_SCORE_DIALOG, history, size, selected_entry);
#line 492 "score-dialog.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 122 "../src/score-dialog.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 500 "score-dialog.c"
}

static void
score_dialog_set_size (ScoreDialog* self,
                       guint8 size)
{
	GtkListStore* _tmp0_;
	History* _tmp1_;
	GList* _tmp2_;
#line 89 "../src/score-dialog.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/score-dialog.vala"
	_tmp0_ = self->priv->score_model;
#line 91 "../src/score-dialog.vala"
	gtk_list_store_clear (_tmp0_);
#line 93 "../src/score-dialog.vala"
	_tmp1_ = self->priv->history;
#line 93 "../src/score-dialog.vala"
	_tmp2_ = _tmp1_->entries;
#line 520 "score-dialog.c"
	{
		GList* entry_collection = NULL;
		GList* entry_it = NULL;
#line 93 "../src/score-dialog.vala"
		entry_collection = _tmp2_;
#line 93 "../src/score-dialog.vala"
		for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
#line 528 "score-dialog.c"
			HistoryEntry* _tmp3_;
			HistoryEntry* entry = NULL;
#line 93 "../src/score-dialog.vala"
			_tmp3_ = _g_object_ref0 ((HistoryEntry*) entry_it->data);
#line 93 "../src/score-dialog.vala"
			entry = _tmp3_;
#line 535 "score-dialog.c"
			{
				HistoryEntry* _tmp4_;
				guint8 _tmp5_;
				guint8 _tmp6_;
				gchar* date_label = NULL;
				HistoryEntry* _tmp7_;
				GDateTime* _tmp8_;
				GDateTime* _tmp9_;
				gchar* _tmp10_;
				gchar* time_label = NULL;
				HistoryEntry* _tmp11_;
				gchar* _tmp12_;
				gint weight = 0;
				HistoryEntry* _tmp13_;
				HistoryEntry* _tmp14_;
				GtkTreeIter iter = {0};
				GtkListStore* _tmp15_;
				GtkTreeIter _tmp16_ = {0};
				GtkListStore* _tmp17_;
				GtkTreeIter _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
				HistoryEntry* _tmp21_;
				HistoryEntry* _tmp22_;
#line 95 "../src/score-dialog.vala"
				_tmp4_ = entry;
#line 95 "../src/score-dialog.vala"
				_tmp5_ = history_entry_get_size (_tmp4_);
#line 95 "../src/score-dialog.vala"
				_tmp6_ = _tmp5_;
#line 95 "../src/score-dialog.vala"
				if (_tmp6_ != size) {
#line 96 "../src/score-dialog.vala"
					_g_object_unref0 (entry);
#line 96 "../src/score-dialog.vala"
					continue;
#line 572 "score-dialog.c"
				}
#line 99 "../src/score-dialog.vala"
				_tmp7_ = entry;
#line 99 "../src/score-dialog.vala"
				_tmp8_ = history_entry_get_date (_tmp7_);
#line 99 "../src/score-dialog.vala"
				_tmp9_ = _tmp8_;
#line 99 "../src/score-dialog.vala"
				_tmp10_ = g_date_time_format (_tmp9_, "%x");
#line 99 "../src/score-dialog.vala"
				date_label = _tmp10_;
#line 101 "../src/score-dialog.vala"
				_tmp11_ = entry;
#line 101 "../src/score-dialog.vala"
				_tmp12_ = history_entry_get_duration_string (_tmp11_);
#line 101 "../src/score-dialog.vala"
				time_label = _tmp12_;
#line 103 "../src/score-dialog.vala"
				weight = (gint) PANGO_WEIGHT_NORMAL;
#line 104 "../src/score-dialog.vala"
				_tmp13_ = entry;
#line 104 "../src/score-dialog.vala"
				_tmp14_ = self->priv->selected_entry;
#line 104 "../src/score-dialog.vala"
				if (_tmp13_ == _tmp14_) {
#line 105 "../src/score-dialog.vala"
					weight = (gint) PANGO_WEIGHT_BOLD;
#line 600 "score-dialog.c"
				}
#line 108 "../src/score-dialog.vala"
				_tmp15_ = self->priv->score_model;
#line 108 "../src/score-dialog.vala"
				gtk_list_store_append (_tmp15_, &_tmp16_);
#line 108 "../src/score-dialog.vala"
				iter = _tmp16_;
#line 109 "../src/score-dialog.vala"
				_tmp17_ = self->priv->score_model;
#line 109 "../src/score-dialog.vala"
				_tmp18_ = iter;
#line 109 "../src/score-dialog.vala"
				_tmp19_ = date_label;
#line 109 "../src/score-dialog.vala"
				_tmp20_ = time_label;
#line 109 "../src/score-dialog.vala"
				gtk_list_store_set (_tmp17_, &_tmp18_, 0, _tmp19_, 1, _tmp20_, 2, weight, -1);
#line 111 "../src/score-dialog.vala"
				_tmp21_ = entry;
#line 111 "../src/score-dialog.vala"
				_tmp22_ = self->priv->selected_entry;
#line 111 "../src/score-dialog.vala"
				if (_tmp21_ == _tmp22_) {
#line 624 "score-dialog.c"
					GtkTreeIter piter = {0};
					GtkTreeIter _tmp23_;
					GtkListStore* _tmp24_;
					gboolean _tmp25_;
					GtkTreeView* _tmp31_;
					GtkListStore* _tmp32_;
					GtkTreeIter _tmp33_;
					GtkTreePath* _tmp34_;
					GtkTreePath* _tmp35_;
#line 113 "../src/score-dialog.vala"
					_tmp23_ = iter;
#line 113 "../src/score-dialog.vala"
					piter = _tmp23_;
#line 114 "../src/score-dialog.vala"
					_tmp24_ = self->priv->score_model;
#line 114 "../src/score-dialog.vala"
					_tmp25_ = gtk_tree_model_iter_previous ((GtkTreeModel*) _tmp24_, &piter);
#line 114 "../src/score-dialog.vala"
					if (_tmp25_) {
#line 644 "score-dialog.c"
						GtkTreeIter ppiter = {0};
						GtkTreeIter _tmp26_;
						GtkListStore* _tmp27_;
						gboolean _tmp28_;
#line 116 "../src/score-dialog.vala"
						_tmp26_ = piter;
#line 116 "../src/score-dialog.vala"
						ppiter = _tmp26_;
#line 117 "../src/score-dialog.vala"
						_tmp27_ = self->priv->score_model;
#line 117 "../src/score-dialog.vala"
						_tmp28_ = gtk_tree_model_iter_previous ((GtkTreeModel*) _tmp27_, &ppiter);
#line 117 "../src/score-dialog.vala"
						if (_tmp28_) {
#line 659 "score-dialog.c"
							GtkTreeIter _tmp29_;
#line 118 "../src/score-dialog.vala"
							_tmp29_ = ppiter;
#line 118 "../src/score-dialog.vala"
							piter = _tmp29_;
#line 665 "score-dialog.c"
						}
					} else {
						GtkTreeIter _tmp30_;
#line 121 "../src/score-dialog.vala"
						_tmp30_ = iter;
#line 121 "../src/score-dialog.vala"
						piter = _tmp30_;
#line 673 "score-dialog.c"
					}
#line 122 "../src/score-dialog.vala"
					_tmp31_ = self->priv->scores;
#line 122 "../src/score-dialog.vala"
					_tmp32_ = self->priv->score_model;
#line 122 "../src/score-dialog.vala"
					_tmp33_ = piter;
#line 122 "../src/score-dialog.vala"
					_tmp34_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp32_, &_tmp33_);
#line 122 "../src/score-dialog.vala"
					_tmp35_ = _tmp34_;
#line 122 "../src/score-dialog.vala"
					gtk_tree_view_scroll_to_cell (_tmp31_, _tmp35_, NULL, FALSE, (gfloat) 0, (gfloat) 0);
#line 122 "../src/score-dialog.vala"
					__vala_GtkTreePath_free0 (_tmp35_);
#line 689 "score-dialog.c"
				}
#line 93 "../src/score-dialog.vala"
				_g_free0 (time_label);
#line 93 "../src/score-dialog.vala"
				_g_free0 (date_label);
#line 93 "../src/score-dialog.vala"
				_g_object_unref0 (entry);
#line 697 "score-dialog.c"
			}
		}
	}
}

static void
score_dialog_size_changed_cb (ScoreDialog* self,
                              GtkComboBox* combo)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gint size = 0;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	gint _tmp5_ = 0;
#line 127 "../src/score-dialog.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/score-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 130 "../src/score-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 130 "../src/score-dialog.vala"
	iter = _tmp0_;
#line 130 "../src/score-dialog.vala"
	if (!_tmp1_) {
#line 131 "../src/score-dialog.vala"
		return;
#line 727 "score-dialog.c"
	}
#line 134 "../src/score-dialog.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 134 "../src/score-dialog.vala"
	_tmp3_ = _tmp2_;
#line 134 "../src/score-dialog.vala"
	_tmp4_ = iter;
#line 134 "../src/score-dialog.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, 1, &_tmp5_, -1);
#line 134 "../src/score-dialog.vala"
	size = _tmp5_;
#line 135 "../src/score-dialog.vala"
	score_dialog_set_size (self, (guint8) size);
#line 741 "score-dialog.c"
}

static void
score_dialog_entry_added_cb (ScoreDialog* self,
                             HistoryEntry* entry)
{
	GtkTreeIter iter = {0};
	guint8 _tmp0_;
	guint8 _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
#line 138 "../src/score-dialog.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/score-dialog.vala"
	g_return_if_fail (entry != NULL);
#line 142 "../src/score-dialog.vala"
	_tmp0_ = history_entry_get_size (entry);
#line 142 "../src/score-dialog.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/score-dialog.vala"
	_tmp3_ = score_dialog_get_size_iter (self, _tmp1_, &_tmp2_);
#line 142 "../src/score-dialog.vala"
	iter = _tmp2_;
#line 142 "../src/score-dialog.vala"
	if (!_tmp3_) {
#line 767 "score-dialog.c"
		gchar* label = NULL;
		guint8 _tmp4_;
		guint8 _tmp5_;
		guint8 _tmp6_;
		guint8 _tmp7_;
		gchar* _tmp8_;
		GtkListStore* _tmp9_;
		GtkTreeIter _tmp10_ = {0};
		GtkListStore* _tmp11_;
		GtkTreeIter _tmp12_;
		const gchar* _tmp13_;
		guint8 _tmp14_;
		guint8 _tmp15_;
		GtkComboBox* _tmp16_;
		gboolean _tmp19_ = FALSE;
		HistoryEntry* _tmp20_;
#line 145 "../src/score-dialog.vala"
		_tmp4_ = history_entry_get_size (entry);
#line 145 "../src/score-dialog.vala"
		_tmp5_ = _tmp4_;
#line 145 "../src/score-dialog.vala"
		_tmp6_ = history_entry_get_size (entry);
#line 145 "../src/score-dialog.vala"
		_tmp7_ = _tmp6_;
#line 145 "../src/score-dialog.vala"
		_tmp8_ = g_strdup_printf (_ ("%u × %u"), (guint) _tmp5_, (guint) _tmp7_);
#line 145 "../src/score-dialog.vala"
		label = _tmp8_;
#line 147 "../src/score-dialog.vala"
		_tmp9_ = self->priv->size_model;
#line 147 "../src/score-dialog.vala"
		gtk_list_store_append (_tmp9_, &_tmp10_);
#line 147 "../src/score-dialog.vala"
		iter = _tmp10_;
#line 148 "../src/score-dialog.vala"
		_tmp11_ = self->priv->size_model;
#line 148 "../src/score-dialog.vala"
		_tmp12_ = iter;
#line 148 "../src/score-dialog.vala"
		_tmp13_ = label;
#line 148 "../src/score-dialog.vala"
		_tmp14_ = history_entry_get_size (entry);
#line 148 "../src/score-dialog.vala"
		_tmp15_ = _tmp14_;
#line 148 "../src/score-dialog.vala"
		gtk_list_store_set (_tmp11_, &_tmp12_, 0, _tmp13_, 1, _tmp15_, -1);
#line 151 "../src/score-dialog.vala"
		_tmp16_ = self->priv->size_combo;
#line 151 "../src/score-dialog.vala"
		if (gtk_combo_box_get_active (_tmp16_) == -1) {
#line 818 "score-dialog.c"
			GtkComboBox* _tmp17_;
			GtkTreeIter _tmp18_;
#line 152 "../src/score-dialog.vala"
			_tmp17_ = self->priv->size_combo;
#line 152 "../src/score-dialog.vala"
			_tmp18_ = iter;
#line 152 "../src/score-dialog.vala"
			gtk_combo_box_set_active_iter (_tmp17_, &_tmp18_);
#line 827 "score-dialog.c"
		}
#line 155 "../src/score-dialog.vala"
		_tmp20_ = self->priv->selected_entry;
#line 155 "../src/score-dialog.vala"
		if (_tmp20_ != NULL) {
#line 833 "score-dialog.c"
			guint8 _tmp21_;
			guint8 _tmp22_;
			HistoryEntry* _tmp23_;
			guint8 _tmp24_;
			guint8 _tmp25_;
#line 155 "../src/score-dialog.vala"
			_tmp21_ = history_entry_get_size (entry);
#line 155 "../src/score-dialog.vala"
			_tmp22_ = _tmp21_;
#line 155 "../src/score-dialog.vala"
			_tmp23_ = self->priv->selected_entry;
#line 155 "../src/score-dialog.vala"
			_tmp24_ = history_entry_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_HISTORY_ENTRY, HistoryEntry));
#line 155 "../src/score-dialog.vala"
			_tmp25_ = _tmp24_;
#line 155 "../src/score-dialog.vala"
			_tmp19_ = _tmp22_ == _tmp25_;
#line 851 "score-dialog.c"
		} else {
#line 155 "../src/score-dialog.vala"
			_tmp19_ = FALSE;
#line 855 "score-dialog.c"
		}
#line 155 "../src/score-dialog.vala"
		if (_tmp19_) {
#line 859 "score-dialog.c"
			GtkComboBox* _tmp26_;
			GtkTreeIter _tmp27_;
#line 156 "../src/score-dialog.vala"
			_tmp26_ = self->priv->size_combo;
#line 156 "../src/score-dialog.vala"
			_tmp27_ = iter;
#line 156 "../src/score-dialog.vala"
			gtk_combo_box_set_active_iter (_tmp26_, &_tmp27_);
#line 868 "score-dialog.c"
		}
#line 142 "../src/score-dialog.vala"
		_g_free0 (label);
#line 872 "score-dialog.c"
	}
}

static gboolean
score_dialog_get_size_iter (ScoreDialog* self,
                            guint8 requested_size,
                            GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gboolean result;
#line 160 "../src/score-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 162 "../src/score-dialog.vala"
	_tmp0_ = self->priv->size_model;
#line 162 "../src/score-dialog.vala"
	_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
#line 162 "../src/score-dialog.vala"
	_vala_iter = _tmp1_;
#line 162 "../src/score-dialog.vala"
	if (_tmp2_) {
#line 896 "score-dialog.c"
		{
			gboolean _tmp3_ = FALSE;
#line 164 "../src/score-dialog.vala"
			_tmp3_ = TRUE;
#line 164 "../src/score-dialog.vala"
			while (TRUE) {
#line 903 "score-dialog.c"
				gint size = 0;
				GtkListStore* _tmp6_;
				GtkTreeIter _tmp7_;
				gint _tmp8_ = 0;
#line 164 "../src/score-dialog.vala"
				if (!_tmp3_) {
#line 910 "score-dialog.c"
					GtkListStore* _tmp4_;
					gboolean _tmp5_;
#line 171 "../src/score-dialog.vala"
					_tmp4_ = self->priv->size_model;
#line 171 "../src/score-dialog.vala"
					_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &_vala_iter);
#line 171 "../src/score-dialog.vala"
					if (!_tmp5_) {
#line 171 "../src/score-dialog.vala"
						break;
#line 921 "score-dialog.c"
					}
				}
#line 164 "../src/score-dialog.vala"
				_tmp3_ = FALSE;
#line 167 "../src/score-dialog.vala"
				_tmp6_ = self->priv->size_model;
#line 167 "../src/score-dialog.vala"
				_tmp7_ = _vala_iter;
#line 167 "../src/score-dialog.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp6_, &_tmp7_, 1, &_tmp8_, -1, -1);
#line 167 "../src/score-dialog.vala"
				size = _tmp8_;
#line 168 "../src/score-dialog.vala"
				if (size == ((gint) requested_size)) {
#line 169 "../src/score-dialog.vala"
					result = TRUE;
#line 169 "../src/score-dialog.vala"
					if (iter) {
#line 169 "../src/score-dialog.vala"
						*iter = _vala_iter;
#line 942 "score-dialog.c"
					}
#line 169 "../src/score-dialog.vala"
					return result;
#line 946 "score-dialog.c"
				}
			}
		}
	}
#line 173 "../src/score-dialog.vala"
	result = FALSE;
#line 173 "../src/score-dialog.vala"
	if (iter) {
#line 173 "../src/score-dialog.vala"
		*iter = _vala_iter;
#line 957 "score-dialog.c"
	}
#line 173 "../src/score-dialog.vala"
	return result;
#line 961 "score-dialog.c"
}

static void
score_dialog_class_init (ScoreDialogClass * klass,
                         gpointer klass_data)
{
#line 24 "../src/score-dialog.vala"
	score_dialog_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/score-dialog.vala"
	g_type_class_adjust_private_offset (klass, &ScoreDialog_private_offset);
#line 24 "../src/score-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = score_dialog_finalize;
#line 974 "score-dialog.c"
}

static void
score_dialog_instance_init (ScoreDialog * self,
                            gpointer klass)
{
#line 24 "../src/score-dialog.vala"
	self->priv = score_dialog_get_instance_private (self);
#line 27 "../src/score-dialog.vala"
	self->priv->selected_entry = NULL;
#line 985 "score-dialog.c"
}

static void
score_dialog_finalize (GObject * obj)
{
	ScoreDialog * self;
#line 24 "../src/score-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCORE_DIALOG, ScoreDialog);
#line 26 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->history);
#line 27 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->selected_entry);
#line 28 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->size_model);
#line 29 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->score_model);
#line 30 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->size_combo);
#line 31 "../src/score-dialog.vala"
	_g_object_unref0 (self->priv->scores);
#line 24 "../src/score-dialog.vala"
	G_OBJECT_CLASS (score_dialog_parent_class)->finalize (obj);
#line 1008 "score-dialog.c"
}

static GType
score_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScoreDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) score_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScoreDialog), 0, (GInstanceInitFunc) score_dialog_instance_init, NULL };
	GType score_dialog_type_id;
	score_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "ScoreDialog", &g_define_type_info, 0);
	ScoreDialog_private_offset = g_type_add_instance_private (score_dialog_type_id, sizeof (ScoreDialogPrivate));
	return score_dialog_type_id;
}

GType
score_dialog_get_type (void)
{
	static volatile gsize score_dialog_type_id__once = 0;
	if (g_once_init_enter (&score_dialog_type_id__once)) {
		GType score_dialog_type_id;
		score_dialog_type_id = score_dialog_get_type_once ();
		g_once_init_leave (&score_dialog_type_id__once, score_dialog_type_id);
	}
	return score_dialog_type_id__once;
}

